

//import robotControl;
import java.awt.EventQueue;

import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenuBar;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JTextField;
import javax.swing.GroupLayout.Alignment;
import javax.swing.LayoutStyle.ComponentPlacement;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JSeparator;


public class RobotInterface {


	
	
	//UI components:
	private JFrame frmHexapodControl;
	
    public int getSlider(){
        return calSlider.getValue();
    }
    public int getLeg(){
        return legSelect.getSelectedIndex();
    }
    public int getServo(){
        return servoSelect.getSelectedIndex();
    }
    public boolean calOn(){//note - the GUI also uses this method to decide if buttons should be greyed out
        return calOn.isSelected();
    }
    public Position getTestPosition(){
    	Position input;
    	try{
    		input = new Position(Double.parseDouble(testX.getText()),
                            Double.parseDouble(testY.getText()),
                            Double.parseDouble(testZ.getText()) );
    	}catch(NumberFormatException e){
    		return new Position(0,0,0);
    	}
    	return input;
    }

    public void setText(String input){
        calLabel2.setText(input);
    }
    public void setText2(String input){
        zeroLabel.setText(input);
    }
    public void setText3(String input){
        gainLabel.setText(input);
    }
    public void setText4(String input){
        text4Label.setText(input);
    }
    public int calAngle = -999;//this is set when you save the angle, and reset to -999 when the main loop grabs the angle
    public boolean saveCal = false;
    public boolean setPlusLim = false;
    public boolean setMinusLim = false;
    public boolean testMove = false;
    public boolean takeStep = false;
    public boolean outputTestData = false;
    private JTextField angleBox;
    private JLabel calLabel2;
    private JCheckBox calOn;
    private javax.swing.JSlider calSlider;
    private JLabel gainLabel;
    private JButton goToPositionButton;
    private JLabel jLabel1;
    private JLabel goalPositionLabel;
    private JLabel jLabel2;
    private JLabel jLabel3;
    private JLabel jLabel4;
    private JLabel jLabel5;
    private JLabel jLabel6;
    private JLabel jLabel7;
    private JLabel jLabel8;
    private JLabel jLabel9;
    private JComboBox legSelect;
    private JPanel mainPanel;
    private JMenuBar menuBar;
    private JButton minusLimButton;
    private JButton plusLimButton;
    private JProgressBar progressBar;
    private JButton saveAngle;
    private JButton saveData;
    private JComboBox servoSelect;
    private JLabel statusAnimationLabel;
    private JLabel statusMessageLabel;
    private JPanel statusPanel;
    private JButton takeStepButton;
    private JTextField testX;
    private JTextField testY;
    private JTextField testZ;
    private JLabel text4Label;
    private JLabel zeroLabel;

    private void saveAngleActionPerformed(java.awt.event.ActionEvent evt) {                                          
        try{
            calAngle = Integer.parseInt(angleBox.getText());
        }
        catch(NumberFormatException e){//the above code will throw an error if you leave the field blank or enter a non-int
            calAngle = -999;
        }
    }                                         

    private void saveDataActionPerformed(java.awt.event.ActionEvent evt) {                                         
        saveCal = true;
    }                                        

    private void plusLimButtonActionPerformed(java.awt.event.ActionEvent evt) {                                              
        setPlusLim = true;
    }                                             

    private void minusLimButtonActionPerformed(java.awt.event.ActionEvent evt) {                                               
        setMinusLim = true;
    }                                              

    private void goToPositionButtonActionPerformed(java.awt.event.ActionEvent evt) {                                                   
        testMove = true;
    }                                                  

    private void takeStepButtonActionPerformed(java.awt.event.ActionEvent evt) {                                               
        takeStep = true;
    }              
    void print(String message){
		consoleTextArea.append(message + "\n");
		//consoleTextArea.setText(consoleTextArea.getText() + message + "\n");//append
		consoleTextArea.setCaretPosition(consoleTextArea.getText().length());//scroll to last character added
	}

    
    
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					RobotInterface window = new RobotInterface();
					window.frmHexapodControl.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	
	/**
	 * Create the application.
	 */
	robotControl myRobotControl;
	public JLabel loadLabel;
	private JTextArea consoleTextArea;
	public JLabel lblCalculatedForces;
	public RobotInterface() {
		initialize();
		myRobotControl = new robotControl(this);//initialize the robot control code. Pass it this window so it can poll for inputs
	}
	

	
	
	/**
	 * Initialize the contents of the frame.
	 */
	
	private void initialize() {
		frmHexapodControl = new JFrame();
		frmHexapodControl.setTitle("Robotic Hexapod Control");
		frmHexapodControl.addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent arg0) {
				myRobotControl.close();
			}
		});
		frmHexapodControl.setBounds(100, 100, 783, 373);
		frmHexapodControl.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frmHexapodControl.getContentPane().setLayout(null);
		
		
		mainPanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        calSlider = new javax.swing.JSlider();
        calSlider.addChangeListener(new ChangeListener() {
        	public void stateChanged(ChangeEvent arg0) {
        		goalPositionLabel.setText("Goal Position: "+calSlider.getValue());
        	}
        });
        calLabel2 = new javax.swing.JLabel();
        legSelect = new javax.swing.JComboBox();
        servoSelect = new javax.swing.JComboBox();
        jLabel3 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        calOn = new javax.swing.JCheckBox();
        saveAngle = new javax.swing.JButton();
        jLabel5 = new javax.swing.JLabel();
        angleBox = new javax.swing.JTextField();
        saveData = new javax.swing.JButton();
        zeroLabel = new javax.swing.JLabel();
        gainLabel = new javax.swing.JLabel();
        plusLimButton = new javax.swing.JButton();
        minusLimButton = new javax.swing.JButton();
        jLabel6 = new javax.swing.JLabel();
        testX = new javax.swing.JTextField();
        testY = new javax.swing.JTextField();
        testZ = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        goToPositionButton = new javax.swing.JButton();
        goalPositionLabel = new javax.swing.JLabel();
        takeStepButton = new javax.swing.JButton();
        text4Label = new javax.swing.JLabel();
        menuBar = new javax.swing.JMenuBar();
        statusPanel = new javax.swing.JPanel();
        javax.swing.JSeparator statusPanelSeparator = new javax.swing.JSeparator();
        statusMessageLabel = new javax.swing.JLabel();
        statusAnimationLabel = new javax.swing.JLabel();
        progressBar = new javax.swing.JProgressBar();

//        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(spiderrobot.SpiderRobotApp.class).getContext().getResourceMap(SpiderRobotView.class);
 //       mainPanel.setBackground(resourceMap.getColor("mainPanel.background")); // NOI18N
 //       mainPanel.setForeground(resourceMap.getColor("mainPanel.foreground")); // NOI18N
        mainPanel.setName("mainPanel"); // NOI18N

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel1.setText("Calibration"); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        calSlider.setMaximum(1023);
        calSlider.setPaintLabels(true);
        calSlider.setPaintTicks(true);
        calSlider.setValue(512);
        calSlider.setName("calSlider"); // NOI18N

        calLabel2.setText("Enable calibration to start"); // NOI18N
        calLabel2.setName("calLabel2"); // NOI18N

        legSelect.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5" }));
        legSelect.setName("legSelect"); // NOI18N

        servoSelect.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "2" }));
        servoSelect.setName("servoSelect"); // NOI18N

        jLabel3.setText("Servo"); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        jLabel2.setLabelFor(legSelect);
        jLabel2.setText("Leg"); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N
        jLabel2.setOpaque(true);

        jLabel4.setName("jLabel4"); // NOI18N

 //       org.jdesktop.beansbinding.Binding binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, calSlider, org.jdesktop.beansbinding.ELProperty.create("${value}"), jLabel4, org.jdesktop.beansbinding.BeanProperty.create("text"));
 //       bindingGroup.addBinding(binding);

        calOn.setText("Enable live calibration (WILL move selected servo)"); // NOI18N
        calOn.setName("calOn"); // NOI18N

        saveAngle.setText("This angle is:"); // NOI18N
        saveAngle.setName("saveAngle"); // NOI18N
        saveAngle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveAngleActionPerformed(evt);
            }
        });

        jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        jLabel5.setText("Degrees"); // NOI18N
        jLabel5.setName("jLabel5"); // NOI18N

        angleBox.setText("0"); // NOI18N
        angleBox.setName("angleBox"); // NOI18N

        saveData.setText("Save Current Calibrations for next time"); // NOI18N
        saveData.setName("saveData"); // NOI18N
        saveData.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveDataActionPerformed(evt);
            }
        });

        zeroLabel.setText("Choose a leg and servo, vary the pulse width,"); // NOI18N
        zeroLabel.setName("zeroLabel"); // NOI18N

        gainLabel.setText("and declare what angle the servo is at"); // NOI18N
        gainLabel.setName("gainLabel"); // NOI18N

        plusLimButton.setText("This is (+) limit"); // NOI18N
        plusLimButton.setName("plusLimButton"); // NOI18N
        plusLimButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                plusLimButtonActionPerformed(evt);
            }
        });

        minusLimButton.setText("This is (-) limit"); // NOI18N
        minusLimButton.setName("minusLimButton"); // NOI18N
        minusLimButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                minusLimButtonActionPerformed(evt);
            }
        });

        jLabel6.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel6.setText("Test Leg Positioning"); // NOI18N
        jLabel6.setName("jLabel6"); // NOI18N

        testX.setText("0"); // NOI18N
        testX.setName("testX"); // NOI18N

        testY.setText("0"); // NOI18N
        testY.setName("testY"); // NOI18N

        testZ.setText("0"); // NOI18N
        testZ.setName("testZ"); // NOI18N

        jLabel7.setLabelFor(legSelect);
        jLabel7.setText("X="); // NOI18N
        jLabel7.setName("jLabel7"); // NOI18N
        jLabel7.setOpaque(true);

        jLabel8.setLabelFor(legSelect);
        jLabel8.setText("Y="); // NOI18N
        jLabel8.setName("jLabel8"); // NOI18N
        jLabel8.setOpaque(true);

        jLabel9.setLabelFor(legSelect);
        jLabel9.setText("Z="); // NOI18N
        jLabel9.setName("jLabel9"); // NOI18N
        jLabel9.setOpaque(true);

        goToPositionButton.setText("Move"); // NOI18N
        goToPositionButton.setName("goToPositionButton"); // NOI18N
        goToPositionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                goToPositionButtonActionPerformed(evt);
            }
        });

        goalPositionLabel.setText("Goal Position: "); // NOI18N
        goalPositionLabel.setName("jLabel10"); // NOI18N

        takeStepButton.setText("Movement Demo"); // NOI18N
        takeStepButton.setName("takeStepButton"); // NOI18N
        takeStepButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                takeStepButtonActionPerformed(evt);
            }
        });

        text4Label.setText("Joint Angles"); // NOI18N
        text4Label.setName("text4Label");
        
        loadLabel = new JLabel("Reported Loads:");
        
        JScrollPane scrollPane = new JScrollPane();
        
        JButton btnPrintTestData = new JButton("Output testing data");
        btnPrintTestData.addActionListener(new ActionListener() {
        	public void actionPerformed(ActionEvent arg0) {
        		outputTestData = true;
        	}
        });
        
        lblCalculatedForces = new JLabel("Calculated Force:");
        
        JSeparator separator = new JSeparator();

        javax.swing.GroupLayout gl_mainPanel = new javax.swing.GroupLayout(mainPanel);
        gl_mainPanel.setHorizontalGroup(
        	gl_mainPanel.createParallelGroup(Alignment.LEADING)
        		.addGroup(gl_mainPanel.createSequentialGroup()
        			.addContainerGap()
        			.addGroup(gl_mainPanel.createParallelGroup(Alignment.LEADING)
        				.addComponent(separator, GroupLayout.DEFAULT_SIZE, 755, Short.MAX_VALUE)
        				.addGroup(gl_mainPanel.createSequentialGroup()
        					.addGroup(gl_mainPanel.createParallelGroup(Alignment.LEADING)
        						.addGroup(gl_mainPanel.createSequentialGroup()
        							.addComponent(calSlider, GroupLayout.PREFERRED_SIZE, 344, GroupLayout.PREFERRED_SIZE)
        							.addPreferredGap(ComponentPlacement.RELATED)
        							.addComponent(jLabel4, GroupLayout.PREFERRED_SIZE, 27, GroupLayout.PREFERRED_SIZE))
        						.addComponent(goalPositionLabel))
        					.addPreferredGap(ComponentPlacement.RELATED)
        					.addGroup(gl_mainPanel.createParallelGroup(Alignment.LEADING)
        						.addComponent(calLabel2)
        						.addComponent(zeroLabel)
        						.addGroup(gl_mainPanel.createSequentialGroup()
        							.addComponent(gainLabel)
        							.addGap(39)
        							.addComponent(text4Label, GroupLayout.DEFAULT_SIZE, 151, Short.MAX_VALUE))))
        				.addComponent(jLabel6)
        				.addGroup(gl_mainPanel.createSequentialGroup()
        					.addGroup(gl_mainPanel.createParallelGroup(Alignment.LEADING)
        						.addGroup(gl_mainPanel.createSequentialGroup()
        							.addComponent(jLabel7)
        							.addPreferredGap(ComponentPlacement.RELATED)
        							.addComponent(testX, GroupLayout.PREFERRED_SIZE, 50, GroupLayout.PREFERRED_SIZE)
        							.addPreferredGap(ComponentPlacement.RELATED)
        							.addComponent(jLabel8, GroupLayout.PREFERRED_SIZE, 16, GroupLayout.PREFERRED_SIZE)
        							.addGap(1)
        							.addComponent(testY, GroupLayout.PREFERRED_SIZE, 50, GroupLayout.PREFERRED_SIZE)
        							.addPreferredGap(ComponentPlacement.RELATED)
        							.addComponent(jLabel9, GroupLayout.PREFERRED_SIZE, 16, GroupLayout.PREFERRED_SIZE)
        							.addPreferredGap(ComponentPlacement.RELATED)
        							.addComponent(testZ, GroupLayout.PREFERRED_SIZE, 50, GroupLayout.PREFERRED_SIZE)
        							.addPreferredGap(ComponentPlacement.UNRELATED)
        							.addComponent(goToPositionButton))
        						.addComponent(loadLabel)
        						.addComponent(lblCalculatedForces)
        						.addGroup(gl_mainPanel.createSequentialGroup()
        							.addGroup(gl_mainPanel.createParallelGroup(Alignment.TRAILING, false)
        								.addGroup(Alignment.LEADING, gl_mainPanel.createSequentialGroup()
        									.addComponent(saveAngle)
        									.addPreferredGap(ComponentPlacement.RELATED)
        									.addComponent(angleBox, GroupLayout.PREFERRED_SIZE, 50, GroupLayout.PREFERRED_SIZE)
        									.addPreferredGap(ComponentPlacement.RELATED)
        									.addComponent(jLabel5)
        									.addPreferredGap(ComponentPlacement.UNRELATED)
        									.addComponent(plusLimButton))
        								.addGroup(gl_mainPanel.createSequentialGroup()
        									.addGroup(gl_mainPanel.createParallelGroup(Alignment.LEADING)
        										.addComponent(calOn, GroupLayout.PREFERRED_SIZE, 296, GroupLayout.PREFERRED_SIZE)
        										.addComponent(jLabel1))
        									.addPreferredGap(ComponentPlacement.RELATED, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        									.addGroup(gl_mainPanel.createParallelGroup(Alignment.LEADING)
        										.addComponent(jLabel2)
        										.addComponent(legSelect, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))))
        							.addPreferredGap(ComponentPlacement.RELATED)
        							.addGroup(gl_mainPanel.createParallelGroup(Alignment.LEADING)
        								.addComponent(jLabel3)
        								.addComponent(servoSelect, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
        								.addComponent(minusLimButton))))
        					.addPreferredGap(ComponentPlacement.RELATED)
        					.addGroup(gl_mainPanel.createParallelGroup(Alignment.LEADING)
        						.addComponent(saveData)
        						.addGroup(gl_mainPanel.createSequentialGroup()
        							.addComponent(takeStepButton)
        							.addPreferredGap(ComponentPlacement.RELATED, 70, Short.MAX_VALUE)
        							.addComponent(btnPrintTestData))
        						.addComponent(scrollPane, GroupLayout.DEFAULT_SIZE, 314, Short.MAX_VALUE))))
        			.addContainerGap())
        );
        gl_mainPanel.setVerticalGroup(
        	gl_mainPanel.createParallelGroup(Alignment.TRAILING)
        		.addGroup(gl_mainPanel.createSequentialGroup()
        			.addContainerGap()
        			.addGroup(gl_mainPanel.createParallelGroup(Alignment.TRAILING)
        				.addGroup(gl_mainPanel.createSequentialGroup()
        					.addComponent(loadLabel)
        					.addGap(5)
        					.addComponent(lblCalculatedForces)
        					.addGap(53))
        				.addComponent(scrollPane, GroupLayout.DEFAULT_SIZE, 108, Short.MAX_VALUE))
        			.addPreferredGap(ComponentPlacement.RELATED)
        			.addGroup(gl_mainPanel.createParallelGroup(Alignment.LEADING)
        				.addGroup(gl_mainPanel.createSequentialGroup()
        					.addComponent(jLabel6)
        					.addPreferredGap(ComponentPlacement.RELATED)
        					.addGroup(gl_mainPanel.createParallelGroup(Alignment.BASELINE)
        						.addComponent(jLabel7)
        						.addComponent(testX, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
        						.addComponent(jLabel8)
        						.addComponent(testY, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
        						.addComponent(jLabel9)
        						.addComponent(testZ, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
        						.addComponent(goToPositionButton)
        						.addComponent(takeStepButton)))
        				.addComponent(btnPrintTestData))
        			.addGap(18)
        			.addComponent(separator, GroupLayout.PREFERRED_SIZE, 3, GroupLayout.PREFERRED_SIZE)
        			.addPreferredGap(ComponentPlacement.RELATED)
        			.addGroup(gl_mainPanel.createParallelGroup(Alignment.BASELINE)
        				.addComponent(jLabel1)
        				.addComponent(jLabel2)
        				.addComponent(jLabel3))
        			.addPreferredGap(ComponentPlacement.RELATED)
        			.addGroup(gl_mainPanel.createParallelGroup(Alignment.BASELINE)
        				.addComponent(calOn)
        				.addComponent(legSelect, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
        				.addComponent(servoSelect, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
        			.addGap(10)
        			.addGroup(gl_mainPanel.createParallelGroup(Alignment.BASELINE)
        				.addComponent(saveAngle)
        				.addComponent(angleBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
        				.addComponent(jLabel5)
        				.addComponent(plusLimButton)
        				.addComponent(minusLimButton)
        				.addComponent(saveData))
        			.addPreferredGap(ComponentPlacement.RELATED)
        			.addGroup(gl_mainPanel.createParallelGroup(Alignment.TRAILING)
        				.addGroup(gl_mainPanel.createSequentialGroup()
        					.addComponent(jLabel4)
        					.addGap(20))
        				.addGroup(gl_mainPanel.createSequentialGroup()
        					.addComponent(calLabel2)
        					.addPreferredGap(ComponentPlacement.RELATED)
        					.addComponent(zeroLabel)
        					.addPreferredGap(ComponentPlacement.RELATED)
        					.addGroup(gl_mainPanel.createParallelGroup(Alignment.BASELINE)
        						.addComponent(gainLabel)
        						.addComponent(text4Label, GroupLayout.PREFERRED_SIZE, 16, GroupLayout.PREFERRED_SIZE)))
        				.addGroup(gl_mainPanel.createSequentialGroup()
        					.addComponent(goalPositionLabel)
        					.addPreferredGap(ComponentPlacement.RELATED)
        					.addComponent(calSlider, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)))
        			.addGap(13))
        );
        
        consoleTextArea = new JTextArea();
        scrollPane.setViewportView(consoleTextArea);
        mainPanel.setLayout(gl_mainPanel);

        menuBar.setName("menuBar"); // NOI18N


        statusPanel.setName("statusPanel"); // NOI18N

        statusPanelSeparator.setName("statusPanelSeparator"); // NOI18N

        statusMessageLabel.setName("statusMessageLabel"); // NOI18N

        statusAnimationLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        statusAnimationLabel.setName("statusAnimationLabel"); // NOI18N

        progressBar.setName("progressBar"); // NOI18N

        javax.swing.GroupLayout gl_statusPanel = new javax.swing.GroupLayout(statusPanel);
        statusPanel.setLayout(gl_statusPanel);
        gl_statusPanel.setHorizontalGroup(
            gl_statusPanel.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(gl_statusPanel.createSequentialGroup()
                .addContainerGap()
                .addComponent(statusMessageLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 598, Short.MAX_VALUE)
                .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(statusAnimationLabel)
                .addContainerGap())
            .addComponent(statusPanelSeparator, javax.swing.GroupLayout.DEFAULT_SIZE, 772, Short.MAX_VALUE)
        );
        gl_statusPanel.setVerticalGroup(
            gl_statusPanel.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, gl_statusPanel.createSequentialGroup()
                .addGap(2, 2, 2)
                .addComponent(statusPanelSeparator, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(gl_statusPanel.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(statusMessageLabel)
                    .addComponent(statusAnimationLabel)
                    .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(3, 3, 3))
        );

        frmHexapodControl.setContentPane(mainPanel);
//        setComponent(mainPanel);
//        setMenuBar(menuBar);
//        setStatusBar(statusPanel);

 //       bindingGroup.bind();
		
		
		
		
		
	}
}
