public class dynamixel_jni //NOTE: This seems to not work if it's under a package in your project directory (e.g. com.yourname.projectname). So leave it just in the src folder. Eclipse will show it as under "(default package)".
{
	public static final int MAXNUM_TXPARAM     = 150;
    public static final int MAXNUM_RXPARAM     = 60;

    public static final int BROADCAST_ID       = 254;
	
	public static final int INST_PING          = 1;
    public static final int INST_READ          = 2;
    public static final int INST_WRITE         = 3;
    public static final int INST_REG_WRITE     = 4;
    public static final int INST_ACTION        = 5;
    public static final int INST_RESET         = 6;
    public static final int INST_SYNC_WRITE    = 131;

    public static final int ERRBIT_VOLTAGE     = 1;
    public static final int ERRBIT_ANGLE       = 2;
    public static final int ERRBIT_OVERHEAT    = 4;
    public static final int ERRBIT_RANGE       = 8;
    public static final int ERRBIT_CHECKSUM    = 16;
    public static final int ERRBIT_OVERLOAD    = 32;
    public static final int ERRBIT_INSTRUCTION = 64;

    public static final int COMM_TXSUCCESS     = 0;
    public static final int COMM_RXSUCCESS     = 1;
    public static final int COMM_TXFAIL        = 2;
    public static final int COMM_RXFAIL        = 3;
    public static final int COMM_TXERROR       = 4;
    public static final int COMM_RXWAITING     = 5;
    public static final int COMM_RXTIMEOUT     = 6;
	public static final int COMM_RXCORRUPT		= 7;
	
	//******************************************************************
	//*	CONTROL TABLE ADDRESSES (same names as in the driver from Servo magazine)
	//******************************************************************
	public static final int MODEL_NUMBER =  0x00;
	public static final int MODEL_NUMBER_H =  0x01;
	public static final int VERSION =  0x02;
	public static final int ID =  0x03;
	public static final int BAUD_RATE =  0x04;
	public static final int RETURN_DELAY_TIME =  0x05;
	public static final int CW_ANGLE_LIMIT =  0x06;
	public static final int CW_ANGLE_LIMIT_H =  0x07;
	public static final int CCW_ANGLE_LIMIT =  0x08;
	public static final int CCW_ANGLE_LIMIT_H =  0x09;
	public static final int RESERVED1 =  0x0A;
	public static final int LIMIT_TEMPERATURE =  0x0B;
	public static final int DOWN_LIMIT_VOLTAGE =  0x0C;
	public static final int UP_LIMIT_VOLTAGE =  0x0D;
	public static final int MAX_TORQUE =  0x0E;
	public static final int MAX_TORQUE_H =  0x0F;
	public static final int STATUS_RETURN_LEVEL =  0x10;	
	public static final int ALARM_LED =  0x11;
	public static final int ALARM_SHUTDOWN =  0x12;
	public static final int RESERVED2 =  0x13;
	public static final int DOWN_CALIBRATION =  0x14;
	public static final int DOWN_CALIBRATION_H =  0x15;
	public static final int UP_CALIBRATION =  0x16;
	public static final int UP_CALIBRATION_H =  0x17;
	public static final int TORQUE_ENABLE =  0x18;
	public static final int LED =  0x19;
	public static final int CW_COMPLIANCE_MARGIN =  0x1A;
	public static final int CCW_COMPLIANCE_MARGIN =  0x1B;
	public static final int CW_COMPLIANCE_SLOPE =  0x1C;
	public static final int CCW_COMPLIANCE_SLOPE =  0x1D;
	public static final int GOAL_POSITION =  0x1E; 
	public static final int GOAL_POSITION_H =  0x1F; 
	public static final int MOVING_SPEED =  0x20; 
	public static final int MOVING_SPEED_H =  0x21; 
	public static final int TORQUE_LIMIT =  0x22;
	public static final int TORQUE_LIMIT_H =  0x23; 
	public static final int PRESENT_POSITION =  0x24; 
	public static final int PRESENT_POSITION_H =  0x25; 
	public static final int PRESENT_SPEED =  0x26; 
	public static final int PRESENT_SPEED_H =  0x27; 
	public static final int PRESENT_LOAD =  0x28; 
	public static final int PRESENT_LOAD_H =  0x29; 
	public static final int PRESENT_VOLTAGE =  0x2A ;
	public static final int PRESENT_TEMPERATURE =  0x2B; 
	public static final int REGISTERED_INSTRUCTION =  0x2C; 
	public static final int RESERVE3 =  0x2D; 
	public static final int MOVING =  0x2E; 
	public static final int LOCK =  0x2F; 
	public static final int PUNCH =  0x30;
	public static final int PUNCH_H = 0x31;



	// device control methods
	public static native int dxl_initialize();
	public static native void dxl_terminate();
	public static native int dxl_get_baud();
	public static native void dxl_set_baud( int baudnum );
	public static native int dxl_get_result();

	// device control methods
	public static native void dxl_tx_packet();
	public static native void dxl_rx_packet();
	public static native void dxl_txrx_packet();

	// set/get packet methods
	public static native void dxl_set_txpacket_id( int id );
	public static native void dxl_set_txpacket_instruction( int instruction );
	public static native void dxl_set_txpacket_parameter( int index, int value );
	public static native void dxl_set_txpacket_length( int length );
	public static native int dxl_get_rxpacket_error( int errbit );
	public static native int dxl_get_rxpacket_length();
	public static native int dxl_get_rxpacket_parameter( int index );

	// utility for value
	public static native int dxl_makeword( int lowbyte, int highbyte );
	public static native int dxl_get_lowbyte( int word );
	public static native int dxl_get_highbyte( int word );

	// high communication methods
	public static native void dxl_ping( int id );
	public static native int dxl_read_byte( int id, int address );
	public static native void dxl_write_byte( int id, int address, int value );
	public static native int dxl_read_word( int id, int address );
	public static native void dxl_write_word( int id, int address, int value );
	
	static
	{
		//System.loadLibrary("dynamixel_jni");
		System.load("C:\\Users\\User\\Desktop\\ICs\\android\\SpiderRobot\\dynamixel_jni.dll");
	}
}
